<script lang="ts">
  import { isBoolean } from '@common/helpers/DataTypeHelper.js';
  import Dialog from '@svelte-ui/modals/Dialog.svelte';
  import { scrollLock } from '@web-common/hooks/browser/scroll-lock.js';
  import { onDestroy, onMount } from 'svelte';

  export let toggle: boolean;
  let prompt = false;
  let gsap: GSAP;
  let dialog: HTMLDivElement;

  const { lock, cleanUp } = scrollLock();

  $: isBoolean(toggle) && (prompt = true);
  $: lock(prompt);
  $: {
    if (dialog) {
      prompt ? show() : hide();
    }
  }

  const show = () => {
    gsap.from(dialog, {
      duration: 0.3,
      scaleX: 0,
      scaleY: 0,
      ease: 'back.easeIn',
    });
  };

  const hide = () => {};

  onMount(async () => {
    gsap = (await import('gsap/all')).gsap;
  });

  onDestroy(() => cleanUp());
</script>

<Dialog
  {prompt}
  interactive
  on:close={() => (prompt = false)}
  ><div
    bind:this={dialog}
    role="dialog"
    class="dialog">
    LOG IN
  </div></Dialog>

<style>
  .dialog {
    width: 500px;
    max-width: calc(100vw - (var(--content-margin) * 2));
    height: 200px;
    max-height: 100%;
    border-radius: var(--radius-4);
    margin: var(--content-margin);
    background-color: white;
  }
</style>
